Name: rpm-build-python
Version: 0.30
Release: alt3

# redefine python_libdir for 0.29.alt2 is buggy 
%define python_libdir %_target_libdir/python%__python_version

Summary: RPM helper macros to rebuild python packages
License: GPL
Group: Development/Other

Source: %name-%version-%release.tar
BuildArch: noarch
Packager: Python Development Team <python@packages.altlinux.org>

Requires: rpm-build >= 0:4.0.4-alt39
Requires: python-base >= 2.4.4-alt8
BuildRequires: python, rpm-build >= 0:4.0.4-alt39
AutoReqProv: yes, nopython

%description
These helper macros provide possibility to rebuild
python modules by some Alt Linux Team Policy compatible way.

%package tools
Summary: diagnostic tools
Group: Development/Python
Requires: %name = %version-%release

%description tools
Package consist small toolset to diaganostic common problem of requires in python modules.

%prep
%setup -q -n %name-%version-%release

%build
subst 's/@PYTHON_VERSION@/%__python_version/g' python

%install
install -pD -m644 python %buildroot%_sysconfdir/rpm/macros.d/python
install -pD -m644 python.env %buildroot%_sysconfdir/rpm/macros.d/python.env
install -pD -m644 python.buildreq %buildroot%_sysconfdir/buildreqs/files/ignore.d/%name
install -pD -m755 python.prov %buildroot%_rpmlibdir/python.prov
install -pD -m755 python.prov.py %buildroot%_rpmlibdir/python.prov.py
install -pD -m755 python.prov.files %buildroot%_rpmlibdir/python.prov.files
install -pD -m755 python.req %buildroot%_rpmlibdir/python.req
install -pD -m755 python.req.py %buildroot%_rpmlibdir/python.req.py
install -pD -m755 python.req.files %buildroot%_rpmlibdir/python.req.files
install -pD -m755 python.compileall.py %buildroot%_rpmlibdir/python.compileall.py
install -pd -m755 %buildroot%python_tooldir/rpm-build
install -pD -m644 bdist_altrpm.py %buildroot%_libdir/python%__python_version/distutils/command/bdist_altrpm.py
install -pD -m755 tools/*py %buildroot%python_tooldir/rpm-build
install -pd -m755 %buildroot%python_tooldir/rpm-build/find
install -pD -m644 tools/find/*py %buildroot%python_tooldir/rpm-build/find
install -pd -m755 %buildroot%_bindir

ln -s `relative %buildroot%python_tooldir/rpm-build/imalyzer.py %buildroot%_bindir/` %buildroot%_bindir/imalyzer
ln -s `relative %buildroot%python_tooldir/rpm-build/requires.py %buildroot%_bindir/` %buildroot%_bindir/py_requires
ln -s `relative %buildroot%python_tooldir/rpm-build/provides.py %buildroot%_bindir/` %buildroot%_bindir/py_provides

unset RPM_PYTHON

%files
%_sysconfdir/rpm/macros.d/python
%_sysconfdir/rpm/macros.d/python.env
%_sysconfdir/buildreqs/files/ignore.d/%name
%_rpmlibdir/python.compileall.py
%_rpmlibdir/python.req
%_rpmlibdir/python.req.py
%_rpmlibdir/python.req.files
%_rpmlibdir/python.prov
%_rpmlibdir/python.prov.py
%_rpmlibdir/python.prov.files
%_libdir/python%__python_version/distutils/command/bdist_altrpm.py
%doc python-module-SAMPLE.spec policy notes doc

%files tools
%_bindir/*
%python_tooldir/rpm-build

%changelog
* Fri Mar 23 2007 Alexey Tourbin <at@altlinux.ru> 0.30-alt3
- Revert "added macros from /usr/lib/rpm/*/macros",
  due to rpm '%%undefine' unexpected behaviour

* Wed Mar 21 2007 Alexey Tourbin <at@altlinux.ru> 0.30-alt2
- python.req.py: restored .py suffix check until rpm-build
  can use python.req.files

* Wed Mar 21 2007 Alexey Tourbin <at@altlinux.ru> 0.30-alt1
- python.req.py:
  + fixed a bug in "import" clause analysis, due to which only
    the first dependency of multiple arguments was produced; i.e.
    Old result: 'import os, re' -> Requires: python2.4(os)
    New result: 'import os, re' -> Requires: python2.4(os), python2.4(re)
  + made it fail on import errors (also python.prov.py)
  + made it print stderr diagnostics when the dependency is being ignored
  + disabled .py suffix check, for the sake of plain python scripts
- added dependency on python-base, so that python.req.py and python.prov.py
  always work (also explained this change in policy/5-Python_FAQ.txt)
- added buildreq skiplist and placed LC_ALL=C as needed in order to avoid
  dumb dependency on encoding modules when e.g. evaluating %%__python_version
- added new files, for possible use with future rpm-build releases:
  + python.req (python.prov) - wrapper for python.req.py (resp. python.prov.py)
  + python.req.files (.prov.files) - will select python files for req/prov
  + /etc/rpm/macros.d/python.env - piece of rpm-build scriplets' preamble
  + also placed rpm-build python macros to /etc/rpm/macros.d/python

* Sat Jan 13 2007 Fr. Br. George <george@altlinux.ru> 0.29-alt5
- (avm@) Search for .pth files in lib64, too
- Minor policy fix
- move distutils extention to %_libdir instead of %_target_libdir

* Mon Dec 11 2006 Fr. Br. George <george@altlinux.ru> 0.29-alt4
- More verbose diagnostic in rpm-build-python-utils
- Minor policy bug fixed

* Sun Dec 03 2006 Fr. Br. George <george@altlinux.ru> 0.29-alt3
- x86_64 adapdation (so it builds equally on any architecture)
- _target_libdir is used
- absolute symlinks turned to relative

* Fri Sep 15 2006 Fr. Br. George <george@altlinux.ru> 0.29-alt2
- Override %%__python_version macro provided by rpm-build (#9974).
- Specfile cleanup.

* Sun Aug 13 2006 Ivan Fedorov <ns@altlinux.ru> 0.29-alt1
- Add support for python 2.5

* Sat Jun 10 2006 Ivan Fedorov <ns@altlinux.ru> 0.28-alt1
- convert text files to UTF-8
- Fix #8855

* Mon Jan 09 2006 Ivan Fedorov <ns@altlinux.ru> 0.27-alt1
- Fixing provides generator to work with ".pth" files

* Mon Jul 25 2005 Andrey Orlov <cray@altlinux.ru> 0.26-alt1
- Generation hierarchical requires fixed

* Wed May 11 2005 Andrey Orlov <cray@altlinux.ru> 0.24-alt2
- Tools renamed

* Tue May 10 2005 Andrey Orlov <cray@altlinux.ru> 0.23-alt2
- Diagnostic tools package added

* Tue Mar 22 2005 Andrey Orlov <cray@altlinux.ru> 0.21-alt2
- Some files moved from /python2.3 to /python2.4

* Wed Feb 02 2005 Andrey Orlov <cray@altlinux.ru> 0.21-alt1
- Draft of new policy version added

* Sat Jan 22 2005 Alexey Morozov <morozov@altlinux.org> 0.20-alt1
- numerous rpm macros enhancements (svn rev. 10)

* Thu Dec 09 2004 Andrey Orlov <cray@altlinux.ru> 0.19-alt1
- Some macros added: (py_requires, py_provides, etc)

* Fri Oct 29 2004 Andrey Orlov <cray@altlinux.ru> 0.18-alt1
- Preliminary fix for python2.4 compatibility has been added

* Wed Oct 27 2004 Andrey Orlov <cray@altlinux.ru> 0.17-alt1
- Documentation is fixed: special thanks for Ivan Fedorov
- Some stupid bugs that damaged tracebacks are fixed. I think all python 
  packages must be rebuilded.

* Tue Oct 05 2004 Andrey Orlov <cray@altlinux.ru> 0.16-alt6
- Splitted module support added
- Recursive module support added

* Sat Sep 11 2004 Andrey Orlov <cray@altlinux.ru> 0.15-alt1
- Policy files are renamed by MHZ request;
- Some macros added (see RpmMacros.txt);
- File "=" don't be created any more (bug);
- python-<modulename> don't be provided any more (bug #4819)

* Fri Sep 10 2004 Andrey Orlov <cray@altlinux.ru> 0.14-alt2
- Some changes from Alexey Morozov <morozov@altlinux.org> added,
  descriptions followed:

- Defined %%__python_package_prefix, typo fixes in macro functions
  documentation;
- Updated Python_MODULE.txt;

* Tue Jul 20 2004 Andrey Orlov <cray@altlinux.ru> 0.13-alt1
- Documentation changed
- Keyword "relaxed" can be used instead "slight"

* Wed Jun 30 2004 Andrey Orlov <cray@altlinux.ru> 0.12-alt3
- Article about "Require python2.3(__future__)" added into FAQ;
- Codec declaration excluded from find req/prov python scripts;

* Wed Jun 23 2004 Andrey Orlov <cray@altlinux.ru> 0.12-alt2
- Python build utilites will be silently exit if python are not fully installed;
- Python auto Prov use *pth files now;

* Thu May 20 2004 Andrey Orlov <cray@altlinux.ru> 0.11-alt1
- Fix some python2.2 incompatibilites

* Tue May 18 2004 Andrey Orlov <cray@altlinux.ru> 0.10-alt3
- Provides detection enchanced (detect old-style <name>module.so library);
- Some historical clauses exluded from bdist_altrpm;
- Some documentation changes;

* Mon May 17 2004 Andrey Orlov <cray@altlinux.ru> 0.9-alt1
- Ready for sysiphus

* Mon May 10 2004 Andrey Orlov <cray@altlinux.ru> 0.8-alt3
- Package rebuilded to use with new rpm

* Sun Apr 25 2004 Andrey Orlov <cray@altlinux.ru> 0.8-alt2
- Some domcmentations added;

* Wed Apr 21 2004 Andrey Orlov <cray@altlinux.ru> 0.8-alt1
- Fix another "BuildNoarch Problem": BuildRequires correctly inserted now;

* Tue Apr 13 2004 Andrey Orlov <cray@altlinux.ru> 0.7-alt1
- Add BuildPreReq: python_devel = X.Y into spec setup function;
- Fix "BuildNoarch Problem"
- Add some documentation

* Sun Mar 28 2004 Andrey Orlov <cray@altlinux.ru> 0.6-alt1
- Debugging operators removed

* Sat Mar 27 2004 Andrey Orlov <cray@altlinux.ru> 0.5-alt1
- Sources put into archive
- BuildPreReq added into setup_python_module

* Thu Mar 25 2004 Andrey Orlov <cray@altlinux.ru> 0.4-alt2
- Command bdist_altrpm for distutils added;
 
* Mon Mar 15 2004 Andrey Orlov <cray@altlinux.ru> 0.3-alt2
- New bytecompiler added
- Defaults treatment enhanced

* Sun Feb 29 2004 Andrey Orlov <cray@altlinux.ru> 0.2-alt2
- Python scripts for find provides and requires added;
- New RPM macros;
- Samples of find-* added;

* Mon Feb 23 2004 Andrey Orlov <cray@altlinux.ru> 0.1-alt1
- Initial release

